// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2002                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
//   DLLɂ摜QƂ̃Tv
//
// 쐬 : K.Kotajima
//
//  : 2002/07/18 
//
// -------------------------------------------------------------------

#include <windows.h>
#include "CircleAverage.h"

/* ------------------------------------------------------------------------
	double WINAPI CircleAreaAverage
		w~̈̉f̕ϔZx߂܂B
		8bitOC摜płB

	
		long lImageAddres	摜̐擪AhX
		long lImageSizeX	摜XTCY
		long lImageSizeY	摜YTCY
		long lImageBPP		摜BPPl
		long lsx		ς߂~̈̒SXW
		long lsy		ς߂~̈̒SYW
		long lradius	ς߂~̈̔a
	Ԓl
		IF@߂ꂽϔZxl
		ُIF@-1
 ------------------------------------------------------------------------- */
double WINAPI CircleAreaAverage( long lImageAddress, long lImageSizeX, long lImageSizeY, long lImageBPP,
																long lcx, long lcy, long lradius )
{
	unsigned char *pImage;		// ڂĂf̃AhX
	unsigned char *pLineTop;
	long i,j;

	RECT rc;						// ~̊Oڐ`
	long lRectSizeX, lRectSizeY;	// Oڐ`̑傫
	long lSqrRadius;				// âQ

	long lx, ly;		// ڂĂf̍W
	long lSum=0;		// ϒlof̘a
	long lPixelNum=0;	// lSumŉZf

	// BPP8ȊOُ͈̎I
	if( lImageBPP != 8 ) return -1;

	// ~̊Oڐ`߂
	rc.left = lcx - lradius;
	rc.top = lcy - lradius;
	rc.right = lcx + lradius;
	rc.bottom = lcy + lradius;
	// ̈悪摜Ƃ܂dȂĂȂꍇُ͈I
	if( (rc.right < 0) | (rc.left >= lImageSizeX) ) return -1;
	if( (rc.bottom < 0) | (rc.top >= lImageSizeY) ) return -1;

	// ͂ݏoĂ镔NbsO
	rc.left = (rc.left < 0) ? 0 : rc.left;
	rc.top = (rc.top < 0) ? 0 : rc.top;
	rc.right = (rc.right >= lImageSizeX) ? lImageSizeX-1 : rc.right;
	rc.bottom = (rc.bottom >= lImageSizeY) ? lImageSizeY-1 : rc.bottom;

	// ̈̃TCYZo
	lRectSizeX = rc.right - rc.left + 1;
	lRectSizeY = rc.bottom - rc.top + 1;
	
	// 󂯎AhXl|C^
	pImage = (unsigned char*)lImageAddress;

	// 炩ߔâQ߂Ă
	lSqrRadius = lradius * lradius;

	// Oڐ`̍Ɉړ
	pImage += lImageSizeX * rc.top + rc.left;
	lx = rc.left; ly = rc.top;

	for( j=0; j<lRectSizeY; j++ ){
		pLineTop = pImage;				// 擪ʒuۑ

		for( i=0; i<lRectSizeX; i++ ){
			// O̒藝𗘗p~̓
			if( (lcx-lx)*(lcx-lx)+(lcy-ly)*(lcy-ly) <= lSqrRadius ){
				lSum += *pImage; lPixelNum++;
			}
			pImage++; lx++;
		}

		pImage = pLineTop + lImageSizeX;	// ̍s
		lx = rc.left; ly++;
	}

	return (double)lSum / (double)lPixelNum;
}
